$Target = $ARGV[0];
$debug = 0;
( $ARGV[1] < 1 ) ? ( $PLCount = 20 ) : ( $PLCount = $ARGV[1] );
$number  = $PLCount;

$Ping = "ping -l 3 -c $PLCount -i .2 -w 5 $Target 2>&1 |";

open(PING, $Ping) || die "U:U\n";
while(<PING>) {
        #64 bytes from 192.168.3.1: icmp_seq=3 ttl=254 time=16.0 ms
        if(/time=(\d+\.?\d*)\sms/) {
                if($1 eq "<") {push(@RTValues, 0)}
                else {push(@RTValues, $1)}
                $PLCount--;
        }
}
close(PING);

#Calculate the Average Round-Trip Time
@RTValues = sort {$a <=> $b} @RTValues;         #Sorts the numbers

$total   += $_ for @RTValues;
$count   = $PLCount;
$average = $total / $number if( $number >= 1 );

#$Average = $Average / $#RTValues;
$average = sprintf("%.2f", $average);           #Round Off Decimals

#Calculate the Packet Loss Percentage
$PacketLoss = $PLCount;
if($PacketLoss == $number) {$average = "U"}

#$RTValues[0] = "U" if( $count < 1 );
$RTValues[$PLCount-1] = "U" if( $number < 1 );

print "icmpAverage:$average " .
      "icmpPacketLoss:$PacketLoss " .
      "icmpPingMin:$RTValues[0] " .
      "icmpPingMax:$RTValues[$count-1] " .
      "icmpPINGcount:$number \n";

if ( $debug ) {
  open( OUTFILE, '>', '/tmp/icmp_statistics.txt' );
  $date = `date`;
  print OUTFILE "\n$date\n" .
                "Round trip values    = @RTValues\n" .
                "Total Count          = $number\n" .
                "Total Value          = $total\n" .
                "Average              = $average\n\n" .
                "INPUT:\n" .
                "ARGV[0](hostname)    = $ARGV[0]\n" .
                "ARGV[1](count)       = $number\n\n" .
                "OUTPUT:\n" .
                "ICMP ave. round trip = $average\n" .
                "ICMP loss count      = $PLCount\n" .
                "ICMP ping min        = $RTValues[0]\n" .
                "ICMP ping max        = $RTValues[$PLCount-1]\n";
  close;
}
